;+
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;
;  widget_pfss_field.pro - a widget application for tracing and drawing the
;                          final field line image specified in the pfss data
;                          browser
;  usage:  widgetid=widget_pfss_field(parent)
;          where parent = widget id of top level base
;
;  M.DeRosa - 20 Feb 2003 - created
;             20 Mar 2003 - revamped a bit, added n_line field to widget
;             24 Mar 2003 - added notes button
;             25 Apr 2003 - added error checking for nlines field
;             25 Apr 2003 - added field line crossing toggle, draw open and/or
;                           closed line buttons
;              9 May 2003 - added ephemeris button, date label, save file
;                           dialog widget to allow the user to specify the 
;                           filename.  Also detects when new data has been
;                           loaded, so that DRAW_FIELD events now
;                           automatically retrace field lines when this
;                           happens 
;             12 May 2003 - changed pfss_field_start_coord call to agree with
;                           new calling sequence
;             30 May 2003 - changed some inaccuracies in the detailed notes
;                           section, as pointed out by Bart
;             11 Dec 2009 - minor widget redesign: made magnification and number
;                           of line entry boxes shorter but wider, removed
;                           display accurate line crossing box (now uses
;                           pfss_draw_field3 all the time), and added options
;                           to control starting point grid type and starting
;                           point height 
;             23 Apr 2010 - fixed an issue with resizing events:wrong value
;                           of draw window size was being assigned
;             13 Sep 2010 - draw widget now cannot be resized less than the
;                           y-opening value (otherwise lots of grayspace
;                           appears below draw window since the buttons to the
;                           left of the draw area take up a minimum amount of
;                           space)
;             11 Apr 2011 - added the roll_angle and roll_center tags to the
;                           map structure example given in the notes (thanks
;                           to Kamen Kozarev for pointing this out) 
;             15 Mar 2013 - renamed "Save to TIFF" button as "Save full
;                           image as TIFF", and added a "Save visible
;                           area as TIFF" button for users who only
;                           wish the extracted area to be saved
;
;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
;-

pro widget_pfss_field_event,event

;  include common block
@pfss_data_block

;  trap window resize events: event.id is same as event.top since they are
;  events generated by the top-level-base widget
if event.id eq event.top then begin

  widget_control,event.top,get_uval=state,/no_copy
  master_geom=widget_info(event.top,/geom)
  oldmasterx=round(master_geom.xsize)
  oldmastery=round(master_geom.ysize)
  newmasterx=event.x
  newmastery=event.y
  view_geom=widget_info(state.wfield,/geom)
  newviewx=round(view_geom.xsize+(newmasterx-oldmasterx))<state.imxsiz
  newviewy=round(view_geom.ysize+(newmastery-oldmastery))<state.imysiz $
    > state.popensiz
  widget_control,state.wfield,xsiz=newviewx,ysiz=newviewy, $
    draw_xsiz=state.imxsiz,draw_ysiz=state.imysiz
  widget_control,state.wfield, $
    set_draw_view=round([state.imxsiz-newviewx,state.imysiz-newviewy]/2)
  widget_control,event.top,set_uval=state,/no_copy

endif else begin

  ;  what happened?
  widget_control,event.id,get_uval=uval,/hourglass
  case uval of
    'CLOSE': widget_control,event.top,/destroy
    'EPHEM': begin
      widget_control,event.top,get_uval=state,/no_copy    
      widget_control,state.wmapbc,set_val=string(b0,f='(f7.3)')
      widget_control,state.wmaplc,set_val=string(l0,f='(f7.3)')
      widgetnow=state.pnow
      if widgetnow ne now then begin
        pfss_trace_field,/oneway
        state.pnow=now
      endif
      widget_control,event.top,set_uval=state,/no_copy    
      render_field,event.top
      end
    'DRAW_FIELD': begin
      widget_control,event.top,get_uval=state,/no_copy
      widgetnow=state.pnow
      if widgetnow ne now then begin
        pfss_trace_field,/oneway
        state.pnow=now
      endif
      widget_control,event.top,set_uval=state,/no_copy
      render_field,event.top
      end
    'TIFF_FULL': begin
      widget_control,event.top,get_uval=state,/no_copy
      tvlct,re,gr,bl,/get
      filename=dialog_pickfile(group=event.top,/write)
      if filename ne '' then begin
        if strmid(filename,strlen(filename)-1,1) eq '/' then begin
          filename=filename+'pfss_image.tiff'
        endif else begin
          dotpos=strpos(filename,'.',/reverse_search)
          if dotpos eq -1 then begin
            filename=filename+'.tiff'
          endif else begin
            suffix=strmid(filename,dotpos,strlen(filename)-dotpos)
            if (suffix ne '.tif') and (suffix ne '.tiff') then $
              filename=filename+'.tiff'
          endelse
        endelse
        print,'  Writing '+filename
        write_tiff,filename,reverse(rimage,3)
        result=dialog_message('Done saving TIFF file.',/info,$
          dialog_parent=event.top)
      endif else print,'  No image file written.'
      widget_control,event.top,set_uval=state,/no_copy
      end
    'TIFF_CUTOUT': begin
      widget_control,event.top,get_uval=state,/no_copy
      tvlct,re,gr,bl,/get
      filename=dialog_pickfile(group=event.top,/write)
      if filename ne '' then begin
        if strmid(filename,strlen(filename)-1,1) eq '/' then begin
          filename=filename+'pfss_image.tiff'
        endif else begin
          dotpos=strpos(filename,'.',/reverse_search)
          if dotpos eq -1 then begin
            filename=filename+'.tiff'
          endif else begin
            suffix=strmid(filename,dotpos,strlen(filename)-dotpos)
            if (suffix ne '.tif') and (suffix ne '.tiff') then $
              filename=filename+'.tiff'
          endelse
        endelse
        print,'  Writing '+filename
        widget_control,state.wfield,get_draw_view=dview
        vgeom=widget_info(state.wfield,/geom)
        szrimage=size(rimage,/dim)
        write_tiff,filename,reverse(rimage(*,$
          (dview(0)>0):((dview(0)+round(vgeom.xsize)-1)<(szrimage(1)-1)),$
          (dview(1)>0):((dview(1)+round(vgeom.ysize)-1)<(szrimage(2)-1))),3)
        result=dialog_message('Done saving TIFF file.',/info,$
          dialog_parent=event.top)
      endif else print,'  No image file written.'
      widget_control,event.top,set_uval=state,/no_copy
      end
    'NEWMAG': begin
      widget_control,event.top,get_uval=state,/no_copy
      widget_control,state.wmapmag,get_val=val
      state.pmag=round(float(val(0)))
      widget_control,event.top,set_uval=state,/no_copy
      end
    'GRID=RANDOM': begin
      widget_control,event.top,get_uval=state,/no_copy
      state.pgrid=uval
      widget_control,event.top,set_uval=state,/no_copy
      end
    'GRID=UNIFORM': begin
      widget_control,event.top,get_uval=state,/no_copy
      state.pgrid=uval
      widget_control,event.top,set_uval=state,/no_copy
      end
    'DRAW_OPEN': begin
      widget_control,event.top,get_uval=state,/no_copy
      state.popen=1b xor state.popen
      widget_control,event.top,set_uval=state,/no_copy
      end
    'DRAW_CLOSED': begin
      widget_control,event.top,get_uval=state,/no_copy
      state.popen=2b xor state.popen
      widget_control,event.top,set_uval=state,/no_copy
      end

    'TRACE_FIELD': begin

      ;  get state
      widget_control,event.top,get_uval=state,/no_copy
      widget_control,state.wparent,get_uval=pstate,/no_copy

      ;  error checking on nlines parameter (and reset if wrong)
      widget_control,state.wmapnlines,get_val=val
      val=round(float(val(0)))
      if val le 0 then begin
        result=dialog_message('Number of lines must be greater than 0',/err,$
          dialog_parent=event.top)
        widget_control,state.wmapnlines,set_val=string(state.pnlines,f='(i6)')
        widget_control,state.wparent,set_uval=pstate,/no_copy
        widget_control,event.top,set_uval=state,/no_copy
        return
      endif
      state.pnlines=val
      widget_control,state.wmapnlines,set_val=string(state.pnlines,f='(i6)')

      ;  get radstart parameter
      widget_control,state.wmapradstart,get_val=val
      state.pradstart=(float(val(0))>min(rix))<max(rix)  ;  bound range

      ;  get field line starting positions
      case state.pgrid of
        'GRID=RANDOM': begin
          pfss_field_start_coord,3,state.pnlines,radstart=state.pradstart, $
            bbox=[pstate.pl1,pstate.pb1,pstate.pl2,pstate.pb2]
          end
        'GRID=UNIFORM': begin

          ;  determine bbox aspect ratio
          lon1=((pstate.pl1+360) mod 360)*!dpi/180
          lon2=((pstate.pl2+360) mod 360)*!dpi/180
          dlon=lon2-lon1
          if dlon le 0 then dlon=dlon+(2*!dpi)         
          dlat=(pstate.pb2-pstate.pb1)*!dpi/180
          aspect=dlat/dlon

          ;  determine how many points in each direction
          nlatpt=round(sqrt(state.pnlines*aspect))
          nlonpt=round(sqrt(state.pnlines/aspect))
          npt=nlatpt*nlonpt

          ;  set starting points
          str=replicate(state.pradstart,npt)
          stth=((90-linrange(nlatpt,pstate.pb2,pstate.pb1))*!dpi/180) # $
            replicate(1,nlonpt)
          stph=replicate(1,nlatpt) # $
            ((linrange(nlonpt,pstate.pl1,pstate.pl1+dlon*180/!dpi) mod 360) $
            *!dpi/180)

          ;  adjust number of lines
          state.pnlines=npt
          widget_control,state.wmapnlines,set_val=string(state.pnlines,f='(i6)')

          end
        else: stop  ;  shouldn't be able to get here
      endcase

      ;  save parameters
      ;str(*)=rix(1)  ;  no longer needed once radstart can be adjusted
      widget_control,state.wparent,set_uval=pstate,/no_copy
      widget_control,event.top,set_uval=state,/no_copy

      ;  do the field-line tracing and then render
      pfss_trace_field;,/oneway
      render_field,event.top

      end
    'NOTES': begin
      print,'  Some detailed notes related to the field line rendering widget:'
      print,'  ---------------------------------------------------------------'
      print,'  Field line output variables:'
      print,'      The three arrays ptr,ptth,ptph contain the coordinates of'
      print,'      all N field lines that have been traced.  Since the field'
      print,'      lines can be of arbitrary length, the array nstep contains'
      print,'      the number of points needed to define the Nth field line.'
      print,'      Thus, field line i (where i is between 0 and N-1) is'
      print,'      represented by the points ptr(0:nstep(i)-1,i), and likewise'
      print,'      for ptth and ptph.'
      print,'  ---------------------------------------------------------------'
      print,'  (r,theta,phi) spherical/heliographic coordinate system:'
      print,'      r is the distance away from sun-center in units of solar'
      print,'      radii, such that valid values are between 1 (the nominal'
      print,'      photosphere and 2.5 (the radius of the source surface).'
      print,'      theta and phi are respectively the colatitude and'
      print,'      longitude in radians.'
      print,'  ---------------------------------------------------------------'
      print,'  Specifying field line starting points:'
      print,'      The widget is currently set up to pick field line starting'
      print,'      points at random within the box specified in the previewer'
      print,'      widget.  To have the tracer draw the field lines passing'
      print,'      through specific points anywhere within the coronal volume,'
      print,'      do the following: (a) if you haven''t done so already,'
      print,'      launch the rendering window, (b) on the command line,'
      print,'      define the str,stth,stph arrays to be coordinates of the'
      print,'      desired starting points, (c) type the command'
      print,'         IDL> pfss_trace_field'
      print,'      on the command line, and (d) hit the "redraw image" button'
      print,'      in the rendering window to display the field lines in the'
      print,'      widget.'
      print,'  ---------------------------------------------------------------'
      print,'  Coordinate transformations:'
      print,'      Once the lat/lon (B,L) of the subsolar point are known, it'
      print,'      is (reasonably) straightforward to convert from heliographic'
      print,'      coordinates (r,theta,phi) to normalized cartesian'
      print,'      coordinates (x,y,z):'
      print,'         x = r*sin(theta)*sin(phi-L)'
      print,'         y =   r*sin(theta)*cos(phi-L)*cos(B) + r*cos(theta)*sin(B)'
      print,'         z = - r*sin(theta)*cos(phi-L)*sin(B) + r*cos(theta)*cos(B)'
      print,'      Here,the (x,z)-plane defines the plane perpendicular to the'
      print,'      viewer (i.e. the image plane) with the x-axis positive'
      print,'      westward and the z-axis positive northward.  The y-axis is'
      print,'      along the line-of-sight and is positive inward (toward the'
      print,'      observer).  Note that (x,y,z) forms a *left*-handed'
      print,'      coordinate system.  The inverse transform is:'
      print,'         r     = sqrt(x^2+y^2+z^2)'
      print,'                         sqrt(x^2+(y*cos(B)+z*sin(B))^2)'
      print,'         theta = arccos( ------------------------------- )' 
      print,'                               -y*sin(B)+z*cos(B)'
      print,'                           sqrt(x^2+(y*cos(B)+z*sin(B))^2)'
      print,'         phi   = L+arcsin( -------------------------------- )'
      print,'                                 -y*sin(B)+z*cos(B)'
      print,'  ---------------------------------------------------------------'
      print,'  SSW Maps:'
      print,'      To generate a Dominic Zarro-style map for use within SSW,'
      print,'      issue the following commands:'
      print,'        IDL> pfss_draw_field,outim=outim,bcent=bcent,lcent=lcent,width=width,mag=mag'
      print,'        IDL> nax=size(outim,/dim)'
      print,'        IDL> map={data:outim,xc:0.0,yc:0.0,dx:2./nax(0),dy:2./nax(1),roll_angle:0.0,roll_center:[0.0,0.0],time:now,xunits:''normalized'',yunits:''normalized'',pfss_cent_l0:lcent,pfss_cent_b0:bcent,id:''PFSS field line map''}'
      print
      print,'      Before calling pfss_draw_field, the following keywords need'
      print,'      to be defined.  They correspond exactly to the fields in'
      print,'      the "PFSS field line renderer" widget:'
      print,'        bcent = map projection latitude in degrees'
      print,'        lcent = map projection Carrington longitude in degrees'
      print,'        width = width of map in units of solar diameters'
      print,'        mag   = magnification factor over nascent magnification'
      print,'                (currently 192x192 pixels for full sun)'
      print
      print,'      Note that the above map is in normalized coordinates, that' 
      print,'      is, disk center is at (0,0) and the limb has a radius of 1.'
      print,'      The image can be scaled to any measurement unit (such as'
      print,'      arcseconds) by multiplying dx and dy by the appropriate '
      print,'      conversion factor (e.g. rsun*width, where rsun is measured'
      print,'      in arcsec).'
      print,'  ---------------------------------------------------------------'
      end
    else: stop  ;  SHOULDN'T BE ABLE TO GET HERE !
  endcase
endelse

end

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

pro render_field,top  ;  (re)draws the display

;  include common block
@pfss_data_block

;  get state
widget_control,top,get_uval=state,/no_copy

;  error checking on centroid
widget_control,state.wmaplc,get_val=curlon
widget_control,state.wmapbc,get_val=curlat
if ((curlon(0) gt 360) or (curlon(0) lt -360)) then begin
  result=dialog_message('Centroid L0 out of range.',/err,dialog_parent=top)
  widget_control,state.wmaplc,set_val=string(state.plc,f='(f7.3)')
  widget_control,top,set_uval=state,/no_copy
  return
endif
if ((curlat(0) gt 90) or (curlat(0) lt -90)) then begin
  result=dialog_message('Centroid B0 must be between -90 and +90.',$
    /err,dialog_parent=top)
  widget_control,state.wmapbc,set_val=string(state.pbc,f='(f7.3)')
  widget_control,top,set_uval=state,/no_copy
  return
endif

;  update state
state.plc=(curlon(0)+360.)mod 360
state.pbc=curlat(0)

;  get magnification
widget_control,state.wmapmag,get_val=val
state.pmag=round(float(val(0)))

;  get frame width
widget_control,state.wmapwidth,get_val=val
state.pwidth=float(val(0))>1.0  ;  renderer chokes if width<1

;  straighten out numbers in text boxes
widget_control,state.wmaplc,set_val=string(state.plc,f='(f7.3)')
widget_control,state.wmapbc,set_val=string(state.pbc,f='(f7.3)')
widget_control,state.wmapnlines,set_val=string(state.pnlines,f='(i6)')
widget_control,state.wmapradstart,set_val=string(state.pradstart,f='(f7.4)')
widget_control,state.wmapmag,set_val=string(state.pmag,f='(i2)')
widget_control,state.wmapwidth,set_val=string(state.pwidth,f='(f5.2)')

;  do the rendering here, puts full image in rimage variable
wset,state.winfield
;; usedrawfield1=(state.pcross eq 'CROSS=OFF') or (state.popen eq 0b) or $
;;               (state.popen eq 2b)
;; if usedrawfield1 then begin
;;   pfss_draw_field,bcent=state.pbc,lcent=state.plc,$
;;     width=state.pwidth,imsc=400,mag=state.pmag,drawopen=state.popen and 1b, $
;;     drawclosed=state.popen and 2b
;; endif else begin
  pfss_draw_field3,bcent=state.pbc,lcent=state.plc,$
    width=state.pwidth,imsc=400,mag=state.pmag,drawopen=state.popen and 1b, $
    drawclosed=state.popen and 2b
;; endelse

;  resize if necessary, otherwise just redraw
nax=size(rimage,/dim)
if n_elements(nax) eq 3 then truecolor=1b else truecolor=0b
if truecolor then begin
  rimnx=nax(1)  &  rimny=nax(2)
endif else begin
  rimnx=nax(0)  &  rimny=nax(1)
endelse
if ((state.imxsiz ne rimnx) or (state.imysiz ne rimny)) then begin
  erase
  state.imxsiz=rimnx
  state.imysiz=rimny
  xsiz=round(nlat*state.pmag*state.pwidth)<state.popensiz
  ysiz=round(nlat*state.pmag*state.pwidth)<state.popensiz
  widget_control,state.wfield,xsiz=xsiz,ysiz=ysiz, $
    draw_xsiz=state.imxsiz,draw_ysiz=state.imysiz
  widget_control,state.wfield, $
    set_draw_view=round([state.imxsiz-xsiz,state.imysiz-ysiz]/2)
endif

;  stick new image in widget
tv,rimage,true=truecolor

;  update date label
widget_control,state.wdatelabel,set_val='Currently displaying data for '+now

;  get parent widget id (for wset command below)
widget_control,state.wparent,get_uval=pstate,/no_copy
win=state.winfield
wset,win
widget_control,state.wparent,set_uval=pstate,/no_copy

;  save state
widget_control,top,set_uval=state,/no_copy

end

;^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

function widget_pfss_field,wparent

;  include common block
@pfss_data_block

;  set defaults
mag=3l
width=1.5  ;  number of solar diameters
opensiz=640
nlines=100l
radstart=rix(1)  ;  units are solar radii

;  construct widget
master=widget_base(/row,title='PFSS field line renderer',group=wparent,$
  /tlb_size_events)
optionbase=widget_base(master,/col)
cancelbut=widget_button(optionbase,val=' Close window ',uval='CLOSE')
savetiffall=widget_button(optionbase,val=' Save full image as TIFF ',$
  uval='TIFF_FULL')
savetiffext=widget_button(optionbase,val=' Save visible area as TIFF ',$
  uval='TIFF_CUTOUT')
redraw=widget_button(optionbase,val=' Redraw image ',uval='DRAW_FIELD')
notebut=widget_button(optionbase,val=' Detailed notes ',uval='NOTES')

;  projection centroid area
centroidbox=widget_base(optionbase,/col,frame=5)
centtitle=widget_label(centroidbox,val='Proj. cent. (deg):')
lbase=widget_base(centroidbox,/row,/align_center)
ltitle=widget_label(lbase,val='L0:')
ltext=widget_text(lbase,xsiz=7,/edit,uval='DRAW_FIELD',font='Courier')
bbase=widget_base(centroidbox,/row,/align_center)
btitle=widget_label(bbase,val='B0:')
btext=widget_text(bbase,xsiz=7,/edit,uval='DRAW_FIELD',font='Courier')
ephembutton=widget_button(centroidbox,val=' Use Earth L0,B0 ', $
  uval='EPHEM', /align_center)

;  magnification area
magbox=widget_base(optionbase,/row,frame=5)
magtitle=widget_label(magbox,val='Magnification:')
magbase=widget_base(magbox,/row,/align_center)
maglabel1=widget_label(magbase,val=' x')
magtext=widget_text(magbase,xsiz=2,/edit,uval='DRAW_FIELD', $
  val=string(mag,f='(i2)'),font='Courier')

;  width area
widthbox=widget_base(optionbase,/col,frame=5)
widthtitle1=widget_label(widthbox,val='Frame width:',/align_left)
widthbase=widget_base(widthbox,/row)
widthtext=widget_text(widthbase,xsiz=5,/edit,uval='DRAW_FIELD', $
  val=string(width,f='(f5.2)'),font='Courier')
widthlabel1=widget_label(widthbase,val='diameters')

;  fieldline starting point area
linebox=widget_base(optionbase,/col,frame=5)
linebase1=widget_base(linebox,/row)
linetitle1=widget_label(linebase1,val='Number of lines:')
linetext1=widget_text(linebase1,xsiz=6,/edit,uval='TRACE_FIELD', $
  val=string(nlines,f='(i6)'),font='Courier')
linebase2=widget_base(linebox,/row)
linebase2a=widget_base(linebase2,/col)
linetitle2a=widget_label(linebase2a,val='Starting height:')
linetitle2b=widget_label(linebase2a,val='(in solar radii)')
linebase2b=widget_base(linebase2,/col)
linetext2=widget_text(linebase2b,xsiz=8,/edit,uval='TRACE_FIELD', $
  val=string(radstart,f='(f7.4)'),font='Courier')
linebase3=widget_base(linebox,/col)
linetitle3=widget_label(linebase3,val='Starting point grid type:')
linebase3a=widget_base(linebase3,/row,/exclusive)
gridbutrand=widget_button(linebase3a,val='Random',uval='GRID=RANDOM')
gridbutunif=widget_button(linebase3a,val='Uniform',uval='GRID=UNIFORM')
widget_control,gridbutrand,/set_button
linebut=widget_button(linebox,val=' Retrace lines ',uval='TRACE_FIELD', $
  /align_center)

;  select which lines to draw
drawbox=widget_base(optionbase,/col,frame=5)
drawtitle1=widget_label(drawbox,val='Draw which lines?')
drawbase=widget_base(drawbox,/row,/nonexclusive)
drawopenbutton=widget_button(drawbase,val='Open ',uval='DRAW_OPEN')
drawclosedbutton=widget_button(drawbase,val='Closed',uval='DRAW_CLOSED')
widget_control,drawopenbutton,/set_button
widget_control,drawclosedbutton,/set_button

;  drawing area
drawarea=widget_base(master,/col)
drawlabel=widget_label(drawarea,val='Currently displaying data for '+now)
draw=widget_draw(drawarea,retain=2,xsiz=nlat*mag*width,ysiz=nlat*mag*width,$
  x_scroll_size=round(nlat*mag*width)<opensiz,$
  y_scroll_size=round(nlat*mag*width)<opensiz)

;  realize
widget_control,master,/realize
widget_control,draw,get_val=windraw
xmanager,'widget_pfss_field',master,/no_block

;  grab projection centroid from previewer
widget_control,wparent,get_uval=pstate,/no_copy
lcent=pstate.plcent
bcent=pstate.pbcent
widget_control,ltext,set_val=string(pstate.plcent,f='(f7.3)')
widget_control,btext,set_val=string(pstate.pbcent,f='(f7.3)')
pstate.wfieldbase=master
widget_control,wparent,set_uval=pstate,/no_copy

;  save state structure (w=widget, win=window, p=parameter, im=image)
state={wparent:wparent, wfield:draw, wmaplc:ltext, wmapbc:btext, $
       wmapmag:magtext, wmapnlines:linetext1, wmapwidth:widthtext, $
       wmapradstart:linetext2, $
       wlinebut:linebut, wdrawbut:redraw, wdatelabel:drawlabel, $
       winfield:windraw, imxsiz:-1l, imysiz:-1l, $
       pmag:mag, pwidth:width, plc:lcent, pbc:bcent, pnlines:100l, $
       pradstart:1.0, pgrid:'GRID=RANDOM', popensiz:opensiz,popen:3b,pnow:now}
;;        popensiz:opensiz,pcross:'CROSS=OFF',popen:3b,pnow:now}
widget_control,master,set_uval=state,/no_copy

;  generate 'TRACE_FIELD' event
widget_control,linetext1,set_uval='TRACE_FIELD',send_event=$
  {ID:linebut,TOP:master,HANDLER:master,TYPE:4}

return,master

end

